using PkmnLib.Plugin.Gen7.Scripts.Status;

namespace PkmnLib.Plugin.Gen7.Scripts.Moves;

[Script(ScriptCategory.Move, "poison_tail")]
public class PoisonTail : Script, IScriptOnSecondaryEffect, IScriptChangeCriticalStage
{
    /// <inheritdoc />
    public void ChangeCriticalStage(IExecutingMove move, IPokemon target, byte hit, ref byte stage)
    {
        if (stage == 255)
            return;
        stage += 1;
    }

    /// <inheritdoc />
    public void OnSecondaryEffect(IExecutingMove move, IPokemon target, byte hit)
    {
        var battleData = move.User.BattleData;
        if (battleData == null)
            return;

        if (battleData.Battle.Random.EffectChance(10, move, target, hit))
        {
            target.SetStatus(ScriptUtils.ResolveName<BadlyPoisoned>(), move.User);
        }
    }
}